Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4561)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 4562)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! bugfix: revised error message for exceeding allow number of time series
+! 
+! 4559 2020-06-11 08:51:48Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -671,6 +674,6 @@
        WRITE( message_string, * ) 'number of time series quantities exceeds',                      &
                                   ' its maximum of dots_max = ', dots_max,                         &
-                                  '&Please increase dots_max in modules.f90.'
-       CALL message( 'init_3d_model', 'PA0194', 1, 2, 0, 6, 0 )
+                                  '&Please increase dots_max in netcdf_interface_mod.f90.'
+       CALL message( 'check_parameters', 'PA0194', 1, 2, 0, 6, 0 )
     ENDIF
 
Index: palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 4561)
+++ palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 4562)
@@ -1,24 +1,23 @@
 !> @file surface_layer_fluxes_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+!
 !
 ! Current revisions:
-! ------------------
+! -----------------
 ! 
 ! 
@@ -26,61 +25,62 @@
 ! -----------------
 ! $Id$
+! File re-formatted to follow the PALM coding standard
+!
+! 4519 2020-05-05 17:33:30Z suehring
 ! Add missing computation of passive scalar scaling parameter
-! 
+!
 ! 4370 2020-01-10 14:00:44Z raasch
-! bugfix: openacc porting for vector version of OL calculation added
-! 
+! Bugfix: openacc porting for vector version of OL calculation added
+!
 ! 4366 2020-01-09 08:12:43Z raasch
-! vector version for calculation of Obukhov length via Newton iteration added
-! 
+! Vector version for calculation of Obukhov length via Newton iteration added
+!
 ! 4360 2020-01-07 11:25:50Z suehring
-! Calculation of diagnostic-only 2-m potential temperature moved to 
-! diagnostic_output_quantities.
-! 
+! Calculation of diagnostic-only 2-m potential temperature moved to diagnostic_output_quantities.
+!
 ! 4298 2019-11-21 15:59:16Z suehring
-! Calculation of 2-m temperature adjusted to the case the 2-m level is above 
-! the first grid point.
-! 
+! Calculation of 2-m temperature adjusted to the case the 2-m level is above the first grid point.
+!
 ! 4258 2019-10-07 13:29:08Z suehring
 ! Initialization of Obukhov lenght also at vertical surfaces (if allocated).
-! 
+!
 ! 4237 2019-09-25 11:33:42Z knoop
 ! Added missing OpenMP directives
-! 
+!
 ! 4186 2019-08-23 16:06:14Z suehring
-! - To enable limitation of Obukhov length, move it before exit-cycle construct. 
-!   Further, change the limit to 10E-5 in order to get rid-off unrealistic 
-!   peaks in the heat fluxes during nighttime
+! - To enable limitation of Obukhov length, move it before exit-cycle construct.
+!   Further, change the limit to 10E-5 in order to get rid-off unrealistic peaks in the heat fluxes
+!   during nighttime
 ! - Unused variable removed
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 3987 2019-05-22 09:52:13Z kanani
 ! Introduce alternative switch for debug output during timestepping
-! 
+!
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
-! of additional debug messages
-! 
+! Changes related to global restructuring of location messages and introduction of additional debug
+! messages
+!
 ! 3881 2019-04-10 09:31:22Z suehring
 ! Assure that Obukhov length does not become zero
-! 
+!
 ! 3834 2019-03-28 15:40:15Z forkel
-! added USE chem_gasphase_mod 
-! 
+! Added USE chem_gasphase_mod
+!
 ! 3787 2019-03-07 08:43:54Z raasch
-! unused variables removed
-! 
+! Unused variables removed
+!
 ! 3745 2019-02-15 18:57:56Z suehring
-! Bugfix, missing calculation of 10cm temperature at vertical building walls, 
-! required for indoor model
-! 
+! Bugfix, missing calculation of 10cm temperature at vertical building walls, required for indoor
+! model
+!
 ! 3744 2019-02-15 18:38:58Z suehring
 ! Some interface calls moved to module_interface + cleanup
-! 
+!
 ! 3668 2019-01-14 12:49:24Z maronga
 ! Removed methods "circular" and "lookup"
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! OpenACC port for SPEC
@@ -92,81 +92,129 @@
 ! Description:
 ! ------------
-!> Diagnostic computation of vertical fluxes in the constant flux layer from the
-!> values of the variables at grid point k=1 based on Newton iteration
+!> Diagnostic computation of vertical fluxes in the constant flux layer from the values of the
+!> variables at grid point k=1 based on Newton iteration.
 !>
-!> @todo (re)move large_scale_forcing actions
-!> @todo check/optimize OpenMP directives
-!> @todo simplify if conditions (which flux need to be computed in which case)
-!------------------------------------------------------------------------------!
+!> @todo (Re)move large_scale_forcing actions
+!> @todo Check/optimize OpenMP directives
+!> @todo Simplify if conditions (which flux need to be computed in which case)
+!--------------------------------------------------------------------------------------------------!
  MODULE surface_layer_fluxes_mod
 
-    USE arrays_3d,                                                             &
-        ONLY:  e, kh, nc, nr, pt, q, ql, qc, qr, s, u, v, vpt, w, zu, zw,      &
-               drho_air_zw, rho_air_zw, d_exner
-
-    USE basic_constants_and_equations_mod,                                     &
-        ONLY:  g, kappa, lv_d_cp, pi, rd_d_rv
-
-    USE chem_gasphase_mod,                                                     &
+    USE arrays_3d,                                                                                 &
+        ONLY:  d_exner,                                                                            &
+               drho_air_zw,                                                                        &
+               e,                                                                                  &
+               kh,                                                                                 &
+               nc,                                                                                 &
+               nr,                                                                                 &
+               pt,                                                                                 &
+               q,                                                                                  &
+               ql,                                                                                 &
+               qc,                                                                                 &
+               qr,                                                                                 &
+               s,                                                                                  &
+               u,                                                                                  &
+               v,                                                                                  &
+               vpt,                                                                                &
+               w,                                                                                  &
+               zu,                                                                                 &
+               zw,                                                                                 &
+               rho_air_zw
+
+
+    USE basic_constants_and_equations_mod,                                                         &
+        ONLY:  g,                                                                                  &
+               kappa,                                                                              &
+               lv_d_cp,                                                                            &
+               pi,                                                                                 &
+               rd_d_rv
+
+    USE chem_gasphase_mod,                                                                         &
         ONLY:  nvar
 
-    USE chem_modules,                                                          &
+    USE chem_modules,                                                                              &
         ONLY:  constant_csflux
 
     USE cpulog
 
-    USE control_parameters,                                                    &
-        ONLY:  air_chemistry, cloud_droplets,                                  &
-               constant_heatflux, constant_scalarflux,                         &
-               constant_waterflux, coupling_mode,                              &
-               debug_output_timestep,                                          &
-               humidity, loop_optimization,                                    &
-               ibc_e_b, ibc_pt_b, indoor_model,                                &
-               land_surface, large_scale_forcing, lsf_surf, message_string,    &
-               neutral, passive_scalar, pt_surface, q_surface,                 &
-               run_coupled, surface_pressure, simulated_time,                  &
-               time_since_reference_point, urban_surface,                      &
-               use_free_convection_scaling, zeta_max, zeta_min
-
-    USE grid_variables,                                                        &
-        ONLY:  dx, dy  
-
-    USE indices,                                                               &
+    USE control_parameters,                                                                        &
+        ONLY:  air_chemistry,                                                                      &
+               cloud_droplets,                                                                     &
+               constant_heatflux,                                                                  &
+               constant_scalarflux,                                                                &
+               constant_waterflux,                                                                 &
+               coupling_mode,                                                                      &
+               debug_output_timestep,                                                              &
+               humidity,                                                                           &
+               ibc_e_b,                                                                            &
+               ibc_pt_b,                                                                           &
+               indoor_model,                                                                       &
+               land_surface,                                                                       &
+               large_scale_forcing,                                                                &
+               loop_optimization,                                                                  &
+               lsf_surf,                                                                           &
+               message_string,                                                                     &
+               neutral,                                                                            &
+               passive_scalar,                                                                     &
+               pt_surface,                                                                         &
+               q_surface,                                                                          &
+               run_coupled,                                                                        &
+               surface_pressure,                                                                   &
+               simulated_time,                                                                     &
+               time_since_reference_point,                                                         &
+               urban_surface,                                                                      &
+               use_free_convection_scaling,                                                        &
+               zeta_max,                                                                           &
+               zeta_min
+
+    USE grid_variables,                                                                            &
+        ONLY:  dx,                                                                                 &
+               dy
+
+    USE indices,                                                                                   &
         ONLY:  nzt
 
     USE kinds
 
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
+    USE bulk_cloud_model_mod,                                                                      &
+        ONLY: bulk_cloud_model,                                                                    &
+              microphysics_morrison,                                                               &
+              microphysics_seifert
 
     USE pegrid
 
-    USE land_surface_model_mod,                                                &
-        ONLY:  aero_resist_kray, skip_time_do_lsm
-
-    USE surface_mod,                                                           &
-        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_type,     &
-                surf_usm_h, surf_usm_v
-        
+    USE land_surface_model_mod,                                                                    &
+        ONLY:  aero_resist_kray,                                                                   &
+               skip_time_do_lsm
+
+    USE surface_mod,                                                                               &
+        ONLY :  surf_def_h,                                                                        &
+                surf_def_v,                                                                        &
+                surf_lsm_h,                                                                        &
+                surf_lsm_v,                                                                        &
+                surf_type,                                                                         &
+                surf_usm_h,                                                                        &
+                surf_usm_v
+
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i              !< loop index x direction
-    INTEGER(iwp) ::  j              !< loop index y direction
-    INTEGER(iwp) ::  k              !< loop index z direction
-    INTEGER(iwp) ::  l              !< loop index for surf type
-
-    LOGICAL      ::  coupled_run       !< Flag for coupled atmosphere-ocean runs
-    LOGICAL      ::  downward = .FALSE.!< Flag indicating downward-facing horizontal surface
-    LOGICAL      ::  mom_uv  = .FALSE. !< Flag indicating calculation of usvs and vsus at vertical surfaces
-    LOGICAL      ::  mom_w   = .FALSE. !< Flag indicating calculation of wsus and wsvs at vertical surfaces
-    LOGICAL      ::  mom_tke = .FALSE. !< Flag indicating calculation of momentum fluxes at vertical surfaces used for TKE production 
-    LOGICAL      ::  surf_vertical     !< Flag indicating vertical surfaces
-
-    REAL(wp)     ::  e_s,               & !< Saturation water vapor pressure
-                     ol_max = 1.0E6_wp, & !< Maximum Obukhov length
-                     z_mo                 !< Height of the constant flux layer where MOST is assumed
-
-    TYPE(surf_type), POINTER ::  surf     !< surf-type array, used to generalize subroutines
+    INTEGER(iwp) ::  i  !< loop index x direction
+    INTEGER(iwp) ::  j  !< loop index y direction
+    INTEGER(iwp) ::  k  !< loop index z direction
+    INTEGER(iwp) ::  l  !< loop index for surf type
+
+    LOGICAL ::  coupled_run         !< Flag for coupled atmosphere-ocean runs
+    LOGICAL ::  downward = .FALSE.  !< Flag indicating downward-facing horizontal surface
+    LOGICAL ::  mom_uv   = .FALSE.  !< Flag indicating calculation of usvs and vsus at vertical surfaces
+    LOGICAL ::  mom_w    = .FALSE.  !< Flag indicating calculation of wsus and wsvs at vertical surfaces
+    LOGICAL ::  mom_tke  = .FALSE.  !< Flag indicating calculation of momentum fluxes at vertical surfaces used for TKE production
+    LOGICAL ::  surf_vertical       !< Flag indicating vertical surfaces
+
+    REAL(wp) :: e_s                !< Saturation water vapor pressure
+    REAL(wp) :: ol_max = 1.0E6_wp  !< Maximum Obukhov length
+    REAL(wp) :: z_mo               !< Height of the constant flux layer where MOST is assumed
+
+    TYPE(surf_type), POINTER ::  surf  !< surf-type array, used to generalize subroutines
 
 
@@ -175,8 +223,8 @@
     PRIVATE
 
-    PUBLIC init_surface_layer_fluxes,                                          &
-           phi_m,                                                              &
-           psi_h,                                                              &
-           psi_m,                                                              &
+    PUBLIC init_surface_layer_fluxes,                                                              &
+           phi_m,                                                                                  &
+           psi_h,                                                                                  &
+           psi_m,                                                                                  &
            surface_layer_fluxes
 
@@ -205,143 +253,161 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Main routine to compute the surface fluxes
-!------------------------------------------------------------------------------!
-    SUBROUTINE surface_layer_fluxes
-
-       IMPLICIT NONE
-
-
-       IF ( debug_output_timestep )  CALL debug_message( 'surface_layer_fluxes', 'start' )
-
-       surf_vertical = .FALSE. !< flag indicating vertically orientated surface elements
-       downward      = .FALSE. !< flag indicating downward-facing surface elements
-!
-!--    Derive potential temperature and specific humidity at first grid level 
-!--    from the fields pt and q
-!
-!--    First call for horizontal default-type surfaces (l=0 - upward facing, 
-!--    l=1 - downward facing)
-       DO  l = 0, 1
-          IF ( surf_def_h(l)%ns >= 1  )  THEN
-             surf => surf_def_h(l)
-             CALL calc_pt_q
-             IF ( .NOT. neutral )  THEN
-                CALL calc_pt_surface
-                IF ( humidity )  THEN
-                   CALL calc_q_surface
-                   CALL calc_vpt_surface
-                ENDIF
+!> Main routine to compute the surface fluxes.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE surface_layer_fluxes
+
+    IMPLICIT NONE
+
+
+    IF ( debug_output_timestep )  CALL debug_message( 'surface_layer_fluxes', 'start' )
+
+    surf_vertical = .FALSE. !< flag indicating vertically orientated surface elements
+    downward      = .FALSE. !< flag indicating downward-facing surface elements
+!
+!-- Derive potential temperature and specific humidity at first grid level from the fields pt and q
+!
+!-- First call for horizontal default-type surfaces (l=0 - upward facing, l=1 - downward facing)
+    DO  l = 0, 1
+       IF ( surf_def_h(l)%ns >= 1  )  THEN
+          surf => surf_def_h(l)
+          CALL calc_pt_q
+          IF ( .NOT. neutral )  THEN
+             CALL calc_pt_surface
+             IF ( humidity )  THEN
+                CALL calc_q_surface
+                CALL calc_vpt_surface
              ENDIF
           ENDIF
-       ENDDO
-!
-!--    Call for natural-type horizontal surfaces
-       IF ( surf_lsm_h%ns >= 1  )  THEN
-          surf => surf_lsm_h
+       ENDIF
+    ENDDO
+!
+!-- Call for natural-type horizontal surfaces
+    IF ( surf_lsm_h%ns >= 1  )  THEN
+       surf => surf_lsm_h
+       CALL calc_pt_q
+    ENDIF
+
+!
+!-- Call for urban-type horizontal surfaces
+    IF ( surf_usm_h%ns >= 1  )  THEN
+       surf => surf_usm_h
+       CALL calc_pt_q
+    ENDIF
+
+!
+!-- Call for natural-type vertical surfaces
+    DO  l = 0, 3
+       IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+          surf => surf_lsm_v(l)
           CALL calc_pt_q
        ENDIF
 
-!
-!--    Call for urban-type horizontal surfaces
-       IF ( surf_usm_h%ns >= 1  )  THEN
-          surf => surf_usm_h
+!--    Call for urban-type vertical surfaces
+       IF ( surf_usm_v(l)%ns >= 1  )  THEN
+          surf => surf_usm_v(l)
           CALL calc_pt_q
        ENDIF
-
-!
-!--    Call for natural-type vertical surfaces
-       DO  l = 0, 3
-          IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+    ENDDO
+
+!
+!-- First, calculate the new Obukhov length, then new friction velocity, followed by the new scaling
+!-- parameters (th*, q*, etc.), and the new surface fluxes, if required. Note, each routine is called
+!-- for different surface types. First call for default-type horizontal surfaces, for natural- and
+!-- urban-type surfaces. Note, here only upward-facing horizontal surfaces are treated.
+
+!
+!-- Default-type upward-facing horizontal surfaces
+    IF ( surf_def_h(0)%ns >= 1 )  THEN
+       surf => surf_def_h(0)
+       CALL calc_uvw_abs
+       IF ( .NOT. neutral )  CALL calc_ol
+       CALL calc_us
+       CALL calc_scaling_parameters
+       CALL calc_surface_fluxes
+    ENDIF
+!
+!-- Natural-type horizontal surfaces
+    IF ( surf_lsm_h%ns >= 1 )  THEN
+       surf => surf_lsm_h
+       CALL calc_uvw_abs
+       IF ( .NOT. neutral )  CALL calc_ol
+       CALL calc_us
+       CALL calc_scaling_parameters
+       CALL calc_surface_fluxes
+    ENDIF
+!
+!-- Urban-type horizontal surfaces
+    IF ( surf_usm_h%ns >= 1 )  THEN
+       surf => surf_usm_h
+       CALL calc_uvw_abs
+       IF ( .NOT. neutral )  CALL calc_ol
+       CALL calc_us
+       CALL calc_scaling_parameters
+       CALL calc_surface_fluxes
+!
+!--    Calculate 10cm temperature, required in indoor model
+       IF ( indoor_model )  CALL calc_pt_near_surface ( '10cm' )
+    ENDIF
+
+!
+!-- Treat downward-facing horizontal surfaces. Note, so far, these are always default type.
+!-- Stratification is not considered in this case, hence, no further distinction between different
+!-- most_method is required.
+    IF ( surf_def_h(1)%ns >= 1 )  THEN
+       downward = .TRUE.
+       surf => surf_def_h(1)
+       CALL calc_uvw_abs
+       CALL calc_us
+       CALL calc_surface_fluxes
+       downward = .FALSE.
+    ENDIF
+!
+!-- Calculate surfaces fluxes at vertical surfaces for momentum and subgrid-scale TKE. No stability
+!-- is considered. Therefore, scaling parameters and Obukhov length do not need to be calculated and
+!-- no distinction in 'circular', 'Newton' or 'lookup' is necessary so far. Note, this will change
+!-- if stability is once considered.
+    surf_vertical = .TRUE.
+!
+!-- Calculate horizontal momentum fluxes at north- and south-facing surfaces(usvs).
+!-- For default-type surfaces
+    mom_uv = .TRUE.
+    DO  l = 0, 1
+       IF ( surf_def_v(l)%ns >= 1 )  THEN
+          surf => surf_def_v(l)
+!
+!--       Compute surface-parallel velocity
+          CALL calc_uvw_abs_v_ugrid
+!
+!--       Compute respective friction velocity on staggered grid
+          CALL calc_us
+!
+!--       Compute respective surface fluxes for momentum and TKE
+          CALL calc_surface_fluxes
+       ENDIF
+    ENDDO
+!
+!-- For natural-type surfaces. Please note, even though stability is not considered for the
+!-- calculation of momentum fluxes at vertical surfaces, scaling parameters and Obukhov length are
+!-- calculated nevertheless in this case. This is due to the requirement of ts in parameterization
+!-- of heat flux in land-surface model in case that aero_resist_kray is not true.
+    IF ( .NOT. aero_resist_kray )  THEN
+       DO  l = 0, 1
+          IF ( surf_lsm_v(l)%ns >= 1 )  THEN
              surf => surf_lsm_v(l)
-             CALL calc_pt_q
-          ENDIF
-
-!--       Call for urban-type vertical surfaces
-          IF ( surf_usm_v(l)%ns >= 1  )  THEN
-             surf => surf_usm_v(l)
-             CALL calc_pt_q
-          ENDIF
-       ENDDO
-
-!
-!--    First, calculate the new Obukhov length, then new friction velocity,
-!--    followed by the new scaling parameters (th*, q*, etc.), and the new
-!--    surface fluxes if required. Note, each routine is called for different surface types. 
-!--    First call for default-type horizontal surfaces, for natural- and 
-!--    urban-type surfaces. Note, at this place only upward-facing horizontal
-!--    surfaces are treated. 
-
-!
-!--    Default-type upward-facing horizontal surfaces
-       IF ( surf_def_h(0)%ns >= 1  )  THEN
-          surf => surf_def_h(0)
-          CALL calc_uvw_abs
-          IF ( .NOT. neutral )  CALL calc_ol
-          CALL calc_us
-          CALL calc_scaling_parameters
-          CALL calc_surface_fluxes
-       ENDIF
-!
-!--    Natural-type horizontal surfaces
-       IF ( surf_lsm_h%ns >= 1  )  THEN
-          surf => surf_lsm_h
-          CALL calc_uvw_abs
-          IF ( .NOT. neutral )  CALL calc_ol
-          CALL calc_us
-          CALL calc_scaling_parameters
-          CALL calc_surface_fluxes
-       ENDIF
-!
-!--    Urban-type horizontal surfaces
-       IF ( surf_usm_h%ns >= 1  )  THEN
-          surf => surf_usm_h
-          CALL calc_uvw_abs
-          IF ( .NOT. neutral )  CALL calc_ol
-          CALL calc_us
-          CALL calc_scaling_parameters
-          CALL calc_surface_fluxes
-!
-!--       Calculate 10cm temperature, required in indoor model
-          IF ( indoor_model )  CALL calc_pt_near_surface ( '10cm' )
-       ENDIF
-
-!
-!--    Treat downward-facing horizontal surfaces. Note, so far, these are 
-!--    always default type. Stratification is not considered
-!--    in this case, hence, no further distinction between different 
-!--    most_method is required.  
-       IF ( surf_def_h(1)%ns >= 1  )  THEN
-          downward = .TRUE.
-          surf => surf_def_h(1)
-          CALL calc_uvw_abs
-          CALL calc_us
-          CALL calc_surface_fluxes
-          downward = .FALSE.
-       ENDIF
-!
-!--    Calculate surfaces fluxes at vertical surfaces for momentum 
-!--    and subgrid-scale TKE.
-!--    No stability is considered. Therefore, scaling parameters and Obukhov-
-!--    length do not need to be calculated and no distinction in 'circular',
-!--    'Newton' or 'lookup' is necessary so far. 
-!--    Note, this will change if stability is once considered.
-       surf_vertical = .TRUE.
-!
-!--    Calculate horizontal momentum fluxes at north- and south-facing 
-!--    surfaces(usvs).
-!--    For default-type surfaces
-       mom_uv = .TRUE. 
-       DO  l = 0, 1
-          IF ( surf_def_v(l)%ns >= 1  )  THEN
-             surf => surf_def_v(l)
 !
 !--          Compute surface-parallel velocity
              CALL calc_uvw_abs_v_ugrid
 !
+!--          Compute Obukhov length
+             IF ( .NOT. neutral )  CALL calc_ol
+!
 !--          Compute respective friction velocity on staggered grid
              CALL calc_us
+!
+!--          Compute scaling parameters
+             CALL calc_scaling_parameters
 !
 !--          Compute respective surface fluxes for momentum and TKE
@@ -350,54 +416,9 @@
        ENDDO
 !
-!--    For natural-type surfaces. Please note, even though stability is not
-!--    considered for the calculation of momentum fluxes at vertical surfaces,
-!--    scaling parameters and Obukov length are calculated nevertheless in this
-!--    case. This is due to the requirement of ts in parameterization of heat
-!--    flux in land-surface model in case of aero_resist_kray is not true.
-       IF ( .NOT. aero_resist_kray )  THEN
-          DO  l = 0, 1
-             IF ( surf_lsm_v(l)%ns >= 1  )  THEN
-                surf => surf_lsm_v(l)
-!
-!--             Compute surface-parallel velocity
-                CALL calc_uvw_abs_v_ugrid
-!
-!--             Compute Obukhov length
-                IF ( .NOT. neutral )  CALL calc_ol
-!
-!--             Compute respective friction velocity on staggered grid
-                CALL calc_us
-!
-!--             Compute scaling parameters
-                CALL calc_scaling_parameters
-!
-!--             Compute respective surface fluxes for momentum and TKE
-                CALL calc_surface_fluxes
-             ENDIF
-          ENDDO
-!
-!--    No ts is required, so scaling parameters and Obukhov length do not need
-!--    to be computed.
-       ELSE
-          DO  l = 0, 1
-             IF ( surf_lsm_v(l)%ns >= 1  )  THEN
-                surf => surf_lsm_v(l)
-!   
-!--             Compute surface-parallel velocity
-                CALL calc_uvw_abs_v_ugrid
-!
-!--             Compute respective friction velocity on staggered grid
-                CALL calc_us
-!
-!--             Compute respective surface fluxes for momentum and TKE
-                CALL calc_surface_fluxes
-             ENDIF
-          ENDDO
-       ENDIF
-!
-!--    For urban-type surfaces
+!-- No ts is required, so scaling parameters and Obukhov length do not need to be computed.
+    ELSE
        DO  l = 0, 1
-          IF ( surf_usm_v(l)%ns >= 1  )  THEN
-             surf => surf_usm_v(l)
+          IF ( surf_lsm_v(l)%ns >= 1 )  THEN
+             surf => surf_lsm_v(l)
 !
 !--          Compute surface-parallel velocity
